; OPT_Res	0	   ; RichMasm thinks this code needs no resources - delete if rsrc.rc is needed
; OPT_Assembler	mlv615
; OPT_Susy	Console
; OPT_Tmp2Asm	1
useMB = 1
if useMB
	include \masm32\MasmBasic\MasmBasic.inc	; http://www.masm32.com/board/index.php?topic=12460
else
	.386
	.model flat,stdcall
	option casemap:none
	include \masm32\include\windows.inc
	include \masm32\include\user32.inc
	includelib \masm32\lib\user32.lib
	include \masm32\include\kernel32.inc
	includelib \masm32\lib\kernel32.lib
	include \masm32\include\gdi32.inc
	includelib \masm32\lib\gdi32.lib
endif

.const
WindowClassName db "Sudoku",0
EditClass db "EDIT",0
ButtonClass db "BUTTON",0
SolveButtonText db "&Solve",0
ClearButtonText db "&Clear",0
btnSolve equ 101
btnClear equ 102
BOX_SIZE equ 30
SPACING equ 5
LINE_STOP equ 325
COORD1 equ 110
COORD2 equ 220

.code
start:
call InitWindow
push eax
call MsgLoop
invoke ExitProcess,eax

InitWindow proc
    local wc:WNDCLASSEX
    local hWnd:HWND
    
    mov   wc.cbSize,SIZEOF WNDCLASSEX
    mov   wc.style, CS_HREDRAW or CS_VREDRAW
    mov   wc.lpfnWndProc, offset WndProc
    mov   wc.cbClsExtra,0
    mov   wc.cbWndExtra,0
    invoke GetModuleHandle,0
    mov   wc.hInstance,eax
    mov   wc.hbrBackground,COLOR_3DFACE+1
    mov   wc.lpszMenuName,0
    mov   wc.lpszClassName,OFFSET WindowClassName
    invoke LoadIcon,0,IDI_WINLOGO
    mov   wc.hIcon,eax
    mov   wc.hIconSm,eax
    invoke LoadCursor,0,IDC_ARROW
    mov   wc.hCursor,eax
    invoke RegisterClassEx, addr wc
    invoke CreateWindowEx,0,\
        ADDR WindowClassName,\
        ADDR WindowClassName,\
        WS_OVERLAPPEDWINDOW,\
        CW_USEDEFAULT,\
        CW_USEDEFAULT,\
        350,\
        410,\
        0,\
        0,\
        wc.hInstance,\
        0
    mov   hWnd,eax
    invoke ShowWindow,hWnd,SW_SHOWDEFAULT
    invoke UpdateWindow,hWnd
    invoke SetWindowPos,hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE
    mov eax,hWnd
    ret
InitWindow endp

MsgLoop proc hWnd:HWND
    local msg:MSG
    local acc[2]:ACCEL
    local accTable:HACCEL
    mov acc[0].fVirt,FVIRTKEY
    mov acc[0].key,VK_RETURN
    mov acc[0].cmd,btnSolve
    mov eax,sizeof ACCEL
    mov acc[eax].fVirt,FVIRTKEY
    mov acc[eax].key,VK_ESCAPE
    mov acc[eax].cmd,btnClear
    invoke CreateAcceleratorTable,addr acc,2
    mov accTable,eax
getmsg:
    invoke GetMessage,addr msg,0,0,0
    or eax,0
    jz exitmsg
    invoke TranslateAccelerator,hWnd,accTable,addr msg
    or eax,0
    jnz getmsg
    invoke TranslateMessage,addr msg
    invoke DispatchMessage,addr msg
    jmp getmsg
exitmsg:
    mov eax,msg.wParam
    ret
MsgLoop endp

SetFont proc hEdit:HWND,iSize:dword
; From MSDN help on CreateFont function
; nHeight = -MulDiv(PointSize, GetDeviceCaps(hDC, LOGPIXELSY), 72);
; Works with CreateButton and OnClearBtn procs
; Fails on every other call from OnCreate
    invoke GetDC,hEdit
    invoke GetDeviceCaps,eax,LOGPIXELSY
    invoke MulDiv,iSize,eax,72
    neg eax
    push eax
    invoke CreateFont,eax,0,0,0,0,0,0,0,0,0,0,0,0,0
    push ecx
    invoke SendMessage,hEdit,WM_SETFONT,eax,TRUE
    pop ecx
    pop edx
    if useMB
    	.if ecx && eax
		deb 4, "SetFont ok for size", edx
	.else
		deb 4, "SetFont: size, error", edx, $Err$()
	.endif
    endif
    ret
SetFont endp

SetFontByLen proc hEdit:HWND,fontlen:dword
; Check the fontlength of the text
; Set size accordingly
    .IF fontlen==0 || fontlen==1
        mov eax,14
    .ELSEIF fontlen==2
        mov eax,12
    .ELSEIF fontlen==3
        mov eax,8
    .ELSE
        mov eax,7
    .ENDIF
    invoke SetFont,hEdit,eax
    ret
SetFontByLen endp

CreateButton proc hWnd:HWND,caption:dword,btnID:word,x:dword
    invoke CreateWindowEx,0,addr ButtonClass,caption,\
        WS_VISIBLE or WS_CHILD or WS_TABSTOP,x,335,75,23,hWnd,btnID,0,0
    invoke SetFont,eax,8
    ret
CreateButton endp

OnCreate proc hWnd:HWND
    local coords[9]:dword
    local txtID:word
    local hEdit:dword
    
    xor ecx,ecx
    ; Boxes are placed in a grid style
    ; Only calculate x-y coordinates once
    ; Used repeatedly in nested loop below
    coordloop:
        .IF ecx==0
            mov eax,SPACING
        .ELSE
            .IF ecx==3 || ecx==6
                add eax,SPACING
            .ENDIF
            add eax,BOX_SIZE+SPACING
        .ENDIF
        mov coords[ecx*4],eax
        inc ecx
        cmp ecx,9
    jne coordloop

    ; ch register is the row counter, cl is the column
    ; cx is used for the control identifier
    ; txtID local variable is used to preserve cx around API calls
    mov ch,9
    rowloop:
        mov cl,9
        colloop:
            mov txtID,cx
            ; Array indexes need to be full 32-bit registers?
            ; Is there a better way?
            ; Copy ch and cl into eax and edx respectively
            xor eax,eax
            mov al,ch
            xor edx,edx
            mov dl,cl
            invoke CreateWindowEx,0, addr EditClass, 0,\
                WS_VISIBLE or WS_CHILD or WS_TABSTOP or WS_BORDER or ES_CENTER or\
                ES_AUTOHSCROLL or ES_AUTOVSCROLL or ES_NUMBER or ES_MULTILINE,\
                coords[edx*4-4], coords[eax*4-4], BOX_SIZE, BOX_SIZE, hWnd, txtID, 0, 0
            mov hEdit,eax ; hEdit stores the handle to the EDIT box
            invoke SetFont,hEdit,8 ; Fails on every other EDIT box.  No idea why.
            invoke SendMessage,hEdit,EM_LIMITTEXT,9,0
            invoke GetDlgCtrlID,hEdit ; Verify that the ID was set correctly
            invoke SetDlgItemInt,hWnd,eax,eax,TRUE ; Display it in the box
            mov cx,txtID
            dec cl
        jnz colloop
        dec ch
    jnz rowloop
    invoke CreateButton,hWnd,addr SolveButtonText,btnSolve,15
    invoke CreateButton,hWnd,addr ClearButtonText,btnClear,100
    ret
OnCreate endp

OnClearBtn proc hWnd:HWND
    local txtID:word

    ; ch register is the row counter, cl is the column
    ; cx is used for the control identifier
    ; txtID local variable is used to preserve cx around API calls
    ; I was using the bx register with the 'uses' clause in the proc header
    ; The SetFont proc (CreateFont) was working consistently on every other EDIT box
    ; Now works correctly every time with local variable :)
    mov ch,9
    clearRloop:
        mov cl,9
        clearCloop:
            mov txtID,cx
            invoke SetDlgItemText,hWnd,txtID,0
            invoke GetDlgItem,hWnd,txtID
            invoke SetFont,eax,14
            mov cx,txtID
            dec cl
        jnz clearCloop
        dec ch
    jnz clearRloop
    ret
OnClearBtn endp

OnPaint proc hWnd:HWND
    local ps:PAINTSTRUCT
    local hDC:HDC

    invoke BeginPaint,hWnd,addr ps
    mov hDC,eax
    invoke MoveToEx,hDC,COORD1,SPACING,0
    invoke LineTo,hDC,COORD1,LINE_STOP
    invoke MoveToEx,hDC,SPACING,COORD1,0
    invoke LineTo,hDC,LINE_STOP,COORD1
    invoke MoveToEx,hDC,COORD2,SPACING,0
    invoke LineTo,hDC,COORD2,LINE_STOP
    invoke MoveToEx,hDC,SPACING,COORD2,0
    invoke LineTo,hDC,LINE_STOP,COORD2

    invoke EndPaint,hWnd,addr ps
    ret
OnPaint endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    .IF uMsg==WM_DESTROY
        invoke PostQuitMessage,0
    .ELSEIF uMsg==WM_CLOSE
        invoke DestroyWindow,hWnd
    .ELSEIF uMsg==WM_CREATE
        invoke OnCreate,hWnd
    .ELSEIF uMsg==WM_PAINT
        invoke OnPaint, hWnd
    .ELSEIF uMsg==WM_COMMAND
        mov eax,wParam
        .IF ax==btnClear
            invoke OnClearBtn,hWnd
        .ELSEIF ax==btnSolve
            ; Not implemented yet
        .ELSE
            shr eax,16
            .IF ax==EN_CHANGE
                ; Setting the font size here always works
                ; Maybe because it's not in a loop???
                invoke GetWindowTextLength,lParam
                invoke SetFontByLen,lParam,eax
            .ENDIF
        .ENDIF
    .ELSE
        invoke DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp
end start